function varargout = comp_test(varargin)
% COMP_TEST M-file for comp_test.fig
%      COMP_TEST, by itself, creates a new COMP_TEST or raises the existing
%      singleton*.
%
%      H = COMP_TEST returns the handle to a new COMP_TEST or the handle to
%      the existing singleton*.
%
%      COMP_TEST('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in COMP_TEST.M with the given input arguments.
%
%      COMP_TEST('Property','Value',...) creates a new COMP_TEST or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before comp_test_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to comp_test_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help comp_test

% Last Modified by GUIDE v2.5 26-Feb-2011 15:26:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @comp_test_OpeningFcn, ...
                   'gui_OutputFcn',  @comp_test_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before comp_test is made visible.
function comp_test_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to comp_test (see VARARGIN)

% Choose default command line output for comp_test
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global SubjName
global SubjSurname
global DateStr
global NumOfCombs
global Permutation
global CurrentPair
global Fs
global Bell1
global Bell2
global Sig
global PairsSet
global Results
global SetOfBells
global NumOfBells
global BellRates
global SubjRes

clear SubjRes
%clear Sig
%clear PairsSet

SubjName    = varargin{1};
SubjSurname  = varargin{2};

Date = clock;
DateStr = datestr(Date, 30);
set(handles.figure1, 'Name', [SubjName '_' SubjSurname '_' DateStr])

Fid = fopen(['Rezultati/' SubjName '_' SubjSurname '_' DateStr '.txt'], 'wt');
fprintf(Fid, [SubjName ' ' SubjSurname ' ' datestr(Date, 0) '\n']);
fclose(Fid);

set(handles.CB_Better1, 'Value', 0)
set(handles.CB_Better2, 'Value', 0)
set(handles.CB_same, 'Value', 0)

BellRates = [98, 93, 592, 600, 514, 244, 244, 494, 249, 382, 49, ...
             329, 1011, 134, 591, 1016, 88, 736, 263, 413, 559, 39];

SetOfBells = [1 4 6 7 11 15 17 18 20 22];
NumOfBells = length(SetOfBells);
Results = zeros(1, NumOfBells);

for i = 1 : NumOfBells
    [SigTmp, Fs] = wavread(['Signali/z' num2str(SetOfBells(i), '%02d') '.wav']);
	Sig(i,:) = SigTmp(1:round(1.1*Fs));
	Energy(i) = sum(Sig(i,:) .* Sig(i,:));
end

% Izjednacavanje po energiji
MaxEnergy = max(Energy) * 0.15;
koef = MaxEnergy ./ Energy;
for i = 1 : NumOfBells
    Sig(i,:) = Sig(i,:) * sqrt(koef(i));	
end


NumOfCombs = NumOfBells * (NumOfBells-1) / 2;
PairsSet = cell(1,NumOfCombs);
for i = 1 : NumOfBells-1
	for j = i+1 : NumOfBells
		PairTmp = [i, j];
		PairPermutation = randperm(2);
		PairsSet((j-2)*(j-1)/2+i) = {[PairTmp(PairPermutation(1)), PairTmp(PairPermutation(2))]};
	end
end

Permutation = randperm(NumOfCombs);

CurrentPair = 1;

set(handles.Txt_Cnt, 'String', [num2str(CurrentPair) ' of ' num2str(NumOfCombs)])

Bell1 = Sig(PairsSet{Permutation(CurrentPair)}(1), :);
Bell2 = Sig(PairsSet{Permutation(CurrentPair)}(2), :);

set(handles.PB_Next, 'Enable', 'off')

% UIWAIT makes comp_test wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = comp_test_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in PB_Bell1.
function PB_Bell1_Callback(hObject, eventdata, handles)
% hObject    handle to PB_Bell1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global Bell1
global Fs
wavplay(Bell1, Fs, 'async')


% --- Executes on button press in PB_Bell2.
function PB_Bell2_Callback(hObject, eventdata, handles)
% hObject    handle to PB_Bell2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global Bell2
global Fs
wavplay(Bell2, Fs, 'async')


% --- Executes on button press in CB_Better1.
function CB_Better1_Callback(hObject, eventdata, handles)
% hObject    handle to CB_Better1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CB_Better1
set(handles.CB_Better2, 'Value', 0)
set(handles.CB_same, 'Value', 0)
set(handles.PB_Next, 'Enable', 'on')


% --- Executes on button press in CB_Better2.
function CB_Better2_Callback(hObject, eventdata, handles)
% hObject    handle to CB_Better2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CB_Better2
set(handles.CB_Better1, 'Value', 0)
set(handles.CB_same, 'Value', 0)
set(handles.PB_Next, 'Enable', 'on')


% --- Executes on button press in CB_same.
function CB_same_Callback(hObject, eventdata, handles)
% hObject    handle to CB_same (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CB_same
set(handles.CB_Better1, 'Value', 0)
set(handles.CB_Better2, 'Value', 0)
set(handles.PB_Next, 'Enable', 'on')


% --- Executes on button press in PB_Next.
function PB_Next_Callback(hObject, eventdata, handles)
% hObject    handle to PB_Next (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global CurrentPair
global Bell1
global Bell2
global Permutation
global PairsSet
global Sig
global NumOfCombs
global SubjName
global SubjSurname
global DateStr
global Results
global SetOfBells
global NumOfBells
%global BellRates
global SubjRes

Bell1State = get(handles.CB_Better1, 'Value');
Bell2State = get(handles.CB_Better2, 'Value');
SameState = get(handles.CB_same, 'Value');

Results(PairsSet{Permutation(CurrentPair)}(1)) = Results(PairsSet{Permutation(CurrentPair)}(1)) + Bell1State + 0.5 * SameState;
Results(PairsSet{Permutation(CurrentPair)}(2)) = Results(PairsSet{Permutation(CurrentPair)}(2)) + Bell2State + 0.5 * SameState;

Bell1Res = Bell1State + 0.5 * SameState;
Bell2Res = Bell2State + 0.5 * SameState;

% Upis u fajl
Fid = fopen(['Rezultati/' SubjName '_' SubjSurname '_' DateStr '.txt'], 'a');
fprintf(Fid, [num2str(CurrentPair, '%02d') ' ' ...
			  'B' num2str(SetOfBells(PairsSet{Permutation(CurrentPair)}(1)), '%02d') '\t'...
			  'B' num2str(SetOfBells(PairsSet{Permutation(CurrentPair)}(2)), '%02d') '\t' ...
			  num2str(Bell1Res) '\t' num2str(Bell2Res) '\n']);
			  %num2str(Bell1State) '\t' num2str(SameState) '\t' num2str(Bell2State) '\n']);
			  
fclose(Fid);

SubjRes(CurrentPair, 1) = CurrentPair;
SubjRes(CurrentPair, 2) = SetOfBells(PairsSet{Permutation(CurrentPair)}(1));
SubjRes(CurrentPair, 3) = SetOfBells(PairsSet{Permutation(CurrentPair)}(2));
SubjRes(CurrentPair, 4) = Bell1State + 0.5 * SameState;
SubjRes(CurrentPair, 5) = Bell2State + 0.5 * SameState;
MatFileName = ['Rezultati/' SubjName '_' SubjSurname '_' DateStr '.mat'];
save(MatFileName, 'SubjRes')

Fid = fopen(['Rezultati/' SubjName '_' SubjSurname '_' DateStr '_overall.txt'], 'wt');
for i = 1 : NumOfBells
	fprintf(Fid, [num2str(SetOfBells(i), '%02d') '\t']);
end
fprintf(Fid, '\n');
for i = 1 : NumOfBells
	fprintf(Fid, [num2str(Results(i), '%02.1f') '\t']);
end
fclose(Fid);


if (CurrentPair==NumOfCombs)
	set(handles.Txt_Cnt, 'String', ['FINISHED all of ' num2str(NumOfCombs)])
	%set(handles.PB_next, 'String', 'Close')
	close(handles.figure1)
end


CurrentPair = CurrentPair + 1;

Bell1 = Sig(PairsSet{Permutation(CurrentPair)}(1), :);
Bell2 = Sig(PairsSet{Permutation(CurrentPair)}(2), :);

set(handles.CB_Better1, 'Value', 0)
set(handles.CB_Better2, 'Value', 0)
set(handles.CB_same, 'Value', 0)

set(handles.Txt_Cnt, 'String', [num2str(CurrentPair) ' of ' num2str(NumOfCombs)])

set(handles.PB_Next, 'Enable', 'off')
